// This example should be on the simpler side
// for a slightly more complex program that shows
// better C style and more C features, see:
// - cat.c
// - read_stdin.c
// - read_stdin.h

#include <unistd.h>  // for read() and write()
#include <stdlib.h>  // for malloc, EXIT_SUCCESS
#include <string.h>  // for strlen

// defines a "constant"
#define MAX_INPUT_SIZE 100


// function declarations need to be seen before they are used.
// otherwise compiler will complain

// reads up to MAX_INPUT_SIZE characters from stdin and returns it
// returns NULL on error or EOF
char* read_stdin();

// prints `to_print` to std_out
void print_stdout(char* to_print);

// modifies the characters refered to by to_trunc
// such that the string now terminates at the end of the first word.
// The end of the first word is marked with a space ' ' character.
void truncate_to_first_word(char* to_trunc);

int main(int argc, char** argv) {
  char* str = read_stdin();
  truncate_to_first_word(str);
  print_stdout(str);

  free(str);

  return EXIT_SUCCESS;
}

void print_stdout(char* to_print) {
  // TODO
  write(STDOUT_FILENO, to_print, strlen(to_print));
}

char* read_stdin() {
  // TODO
  char* str = malloc(MAX_INPUT_SIZE * sizeof(char));
  if (str == NULL) {
    return NULL;
  }
  read(STDIN_FILENO, str, MAX_INPUT_SIZE);
  return str;
}

void truncate_to_first_word(char* to_trunc) {
  // TODO
  size_t len = strlen(to_trunc);
  for (size_t i = 0; i < len; i++) {
    if (to_trunc[i] == ' ') {
      to_trunc[i] = '\0';
      break;
    }
  }
}
